/*Tablas de Capas*/

function MT_setColumnsTable(title,columnsName)
{
	
	$("#title_table_layer_records").text(title);
	
	var htmlinfo="<table id='table_Layer' class='display' cellspacing='0' width='100%'><thead><tr>";
	
	htmlinfo=htmlinfo+"<th><div></div></th>";
	for(var i=0;i<columnsName.length;i++)
		htmlinfo=htmlinfo+"<th>"+columnsName[i]+"</th>";
	
	htmlinfo=htmlinfo+"</tr></thead><tfoot></tfoot></table>";
	$("#content_table_Layer").append(htmlinfo);

}

function MT_adjustColumnsTable()
{
	var referencia = $($("#table_Layer").find("tbody").find("tr")[0]).find("td").toArray();
	
	
	
	setTimeout(function(){
		$("#table_Layer_wrapper").find(".dataTables_scrollHead").find("table.dataTable").find("thead").find("tr").find("th").each(function( index ) {
			
			var width_calc = $(referencia[index]).prop("clientWidth");
			
			$( this ).attr("style","width:"+width_calc+"px; min-width:"+width_calc+"px !important; max-width:"+width_calc+"px !important;");
		});
		$(window).trigger("resize");
		
	}, 250);

}


var table_records_esquematicos;


function MT_openRecords(layerid)
{
	
	
	$.ajax({
		  type: "GET",
		  url: "client/getTableConfig?idlayer="+layerid,
		  contentType: 'application/json',
		  success: function(data) {
	
		  
			    $("#content_table_Layer").empty();

				/*MEsquematicos_setColumnsTable(["Nomenclatura"]);

				var columns = [{data:"tools",mData:"tools"},{data:"nomencla",mData:"nomencla"}];*/
				
			    MT_setColumnsTable(data.title, data.columnsName.split(","));
			  
				table_records = $('#table_Layer').DataTable( {
					"searching": true,
			        "scrollX":true,
					"processing": true,
			        "serverSide": true,
			        "lengthChange": false,
			        "bSort" : false,
			        "columns": data.columns,
			        "language": {
			            "sProcessing":     "Procesando...",
			            "sLengthMenu":     "Mostrar _MENU_ registros",
			            "sZeroRecords":    "No se encontraron resultados",
			            "sEmptyTable":     "Ning&uacute;n dato disponible en esta tabla",
			            "sInfo":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
			            "sInfoEmpty":      "Mostrando registros del 0 al 0 de un total de 0 registros",
			            "sInfoFiltered":   "(filtrado de un total de _MAX_ registros)",
			            "sInfoPostFix":    "",
			            "sSearch":         "Buscar:",
			            "sUrl":            "",
			            "sInfoThousands":  ",",
			            "sLoadingRecords": "Cargando...",
			            "oPaginate": {
			                "sFirst":    "Primero",
			                "sLast":     "&Uacute;ltimo",
			                "sNext":     "Siguiente",
			                "sPrevious": "Anterior"
			            },
			            
			            "aoColumnDefs": [
			                             { "sWidth": "10%", "aTargets": [ -1 ] }
			                         ],
			            "oAria": {
			                "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
			                "sSortDescending": ": Activar para ordenar la columna de manera descendente"
			            }
			        },
			        
			        
			        "ajax": {
			        	"type":"POST",
			            "url": "client/getTableLayer",
			            "data": {
			            			idlayer: layerid,
			            			projection:map.projection
			            		},
	    	            "dataSrc": function (json) {
	    	            	
	            		      var return_data = new Array();
	            		      for(var i=0;i< json.data.length; i++){
	            		    	  
	            		    	var obj = json.data[i];
	            		    	  
	            		    	obj.zoom = "<button class='btn btn-primary btn-sm fa fa-search buttons-custom-layer-panel' title='Zoom' onclick='MT_zoomToWKT(\""+json.data[i].zoom+"\")'></button>";  
	            		    	  
	            		        return_data.push(obj);
	            		      }
	            		      return return_data;
	            		    }		
			            		
			        },
			        
			        "drawCallback": function (settings) { 
			        	
						 $('#modal-content_layer_records').off('show.bs.modal');
						 
						 $('#modal-content_layer_records').on('show.bs.modal', function () {
							 
							 if($('#table_Layer').find("thead").length>0)
								 MT_adjustColumnsTable(); 
								 
							 
						 });
						 $('#modal-content_layer_records').modal('show');
			        }
			
			    });
		  }
	});

}


function MT_zoomToWKT(wkt)
{
	ML_addAndZoomToWKT(wkt,map.projection);
	$('#modal-content_layer_records').modal('hide');
	
	$("#map").trigger('zoomToWKT', wkt);

}

function MT_downloadRecordsGeoJson(idlayer,title)
{
	var xhr = new XMLHttpRequest();
	xhr.open('GET', "client/getAllRecordsLayerGeoJson?idlayer="+idlayer, true);
	xhr.responseType = 'blob';
	 
	xhr.onload = function(e) {
	  if (this.status == 200) {
	    // get binary data as a response
	    var blob = this.response;
	    
	    saveAs(blob, title+".geojson");

	  }
	};
	xhr.send();
}


function MT_downloadRecords(idlayer,title)
{
	$.ajax({
    	url: "client/getAllRecordsOfLayer?idlayer="+idlayer,
    	type: "GET",
        contentType: 'application/text; charset=utf-8',
        success: function(data) {
        	var response = data.namescolumns+"\n";
        	//parsear el data para construir el contenido del archivo
        	
        	$.each(data.records, function(id, element ) {
        		response = response + element + "\n";
			});
        	
        	var link = document.createElement("a");
        	link.setAttribute("href", "data:text/csv;charset=utf-8,%EF%BB%BF" + encodeURIComponent(response));
        	link.setAttribute("download", title+".csv");
        	link.click(); 
        	
        },
        error: function (xhr, textStatus, errorThrown) {
        	
        	console.log(textStatus);
        	
        	console.log(errorThrown);
        	
        	bootbox.alert("No se pudo descargar el archivo");
        }
    });
}